//+------------------------------------------------------------------+
//|                                                main.mq4          |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
/*
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Turquoise
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 Silver
*/

#define MAGICMA  20060415
extern double Lots=0.01;
extern int    SL=700;

extern int    Length =13;       // Bollinger Bands Period
extern double Deviation =1.62;    // Deviation was 2
extern double MoneyRisk =1.00; // Offset Factor
extern int    SignalMode =1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals; 3-no Signals;
extern int    Line=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars=1500;
extern bool   AlertSoundON=false;
extern int TimeFrame = 0;
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string  note___SignalMode = "1-Signals&Stops;0-onlyStops;2-onlySignals;3-noSignals";

int i;
bool BuyDay = false;

double Tick;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   //----

   //----
   return(0);
   }
   
double ND(double A)
{
 return(MathRound(A/Tick)*Tick);
}     


bool AllOrderClose()
{
//   
for(i = OrdersTotal()-1; i >= 0; i--)
   //   
   if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES))
      {
      if (OrderType()==OP_BUY)
         if (!OrderClose(OrderTicket(),OrderLots(),Bid,300,Blue))
            Alert("     Buy: "+GetLastError());
      if (OrderType()==OP_SELL)
         if (!OrderClose(OrderTicket(),OrderLots(),Ask,300,Red))
            Alert("     Sell: "+GetLastError());
      if (OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP)
         if (!OrderDelete(OrderTicket()))
            Alert("    : "+GetLastError());
      }
//BuyDay=false;         
}

bool CheckExist(int Type)
{
 for(int i = OrdersTotal()-1; i >= 0; i--)
   if(OrderSelect(i, SELECT_BY_POS))
     //if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
     if(OrderSymbol() == Symbol())   
       if(OrderType() == Type)
         return(True); 
 return(False);        
}

double BuySignal, SellSignal;
double BuySignal_old, SellSignal_old;


int start()
{  
if (BuySignal > 0)
   BuySignal_old=BuySignal;
if (SellSignal > 0)
   SellSignal_old=SellSignal;


BuySignal=iCustom(NULL, 0, "BBands_StopsV1A_mtf",Length,Deviation,MoneyRisk,SignalMode,Line,Nbars,AlertSoundON,TimeFrame,note_TimeFrames,note___SignalMode,2,1);
SellSignal=iCustom(NULL, 0, "BBands_StopsV1A_mtf",Length,Deviation,MoneyRisk,SignalMode,Line,Nbars,AlertSoundON,TimeFrame,note_TimeFrames,note___SignalMode,3,1);

//if ((BuySignal_old*1.0001 < BuySignal || BuySignal_old*0.9999 > BuySignal) && BuySignal > 0)
if (BuySignal > 0)
   {
   //  Sell - 
   if (CheckExist(OP_SELL))
      AllOrderClose();   
   // Buy
   if (!CheckExist(OP_BUY))
      if (OrderSend(Symbol(), OP_BUY, Lots, ND(Ask), 500, ND(Bid-SL*Point), 0, "", 20060415, 0, Blue) == -1)
         Alert("     Buy : "+GetLastError());
      //Alert("Buy signal= "+BuySignal);
   }
   
//if ((SellSignal_old*1.0001 < SellSignal || SellSignal_old*0.9999 > SellSignal) && SellSignal>0)
if (SellSignal>0)
   {
   //  Buy - 
   if (CheckExist(OP_BUY))
      AllOrderClose();
   // Sell
   if (!CheckExist(OP_SELL))
      if (OrderSend(Symbol(), OP_SELL, Lots, ND(Bid), 500, ND(Ask+SL*Point), 0, "", 20060415, 0, Red) == -1)
         Alert("     Buy : "+GetLastError());

      //Alert("Sell signal= "+SellSignal);
   }


return(0);

}


